/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

(function(){
   
dojo.provide("com.ibm.team.vvc.server.core.ui.history.HistoryPage");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("net.jazz.ajax.ui.PlatformUI");


dojo.require('dojo.i18n');
dojo.require("jazz.ui.Breadcrumbs");
dojo.require("com.ibm.team.vvc.shared.web.ui.history.HistoryWidget");

dojo.require("com.ibm.team.vvc.server.core.ui.internal.util.PageUtil");

dojo.requireLocalization("com.ibm.team.vvc.server.core.ui.history", "HistoryPageMessages");

(function ()
{
	var PlatformUI = net.jazz.ajax.ui.PlatformUI;
	
	dojo.declare("com.ibm.team.vvc.server.core.ui.history.HistoryPage", [dijit._Widget, dijit._Templated], {
	  
		widgetsInTemplate: true,
		
		templatePath: dojo.moduleUrl('com.ibm.team.vvc.server.core', 'ui/history/templates/HistoryPage.html'),
	   
		constructor: function() {
			
			this.messages = dojo.i18n.getLocalization("com.ibm.team.vvc.server.core.ui.history", "HistoryPageMessages");
		},
		
		postCreate: function(){
			var self = this;
			// Register the page action
			var ActionRegistry = PlatformUI.getWorkbench().getActionRegistry();
			ActionRegistry.registerAction("vvc.showHistory", this, "showHistory");
			
		},
	   
		showHistory: function() {
			this._constructBreadcrumbs();
			this._constructHistoryWidgit();
		},
		
		_constructBreadcrumbs:function()
		{
			if (!this._breadcrumbs)
			{
				this._breadcrumbs = new jazz.ui.Breadcrumbs({segments: [
					{
						label: this.messages.history, 
						href : '#action=vvc.showHistory'
					}
				]});
		
				this._breadcrumbs.placeAt(dojo.byId("breadcrumbs"));
			}
		},
		
		
		_constructHistoryWidgit: function() {
			if (!this._historyWidget)
			{
				this._historyWidget = new com.ibm.team.vvc.shared.web.ui.history.HistoryWidget();
				
			    /* append the new grid to the div */
			    this._mainDiv.appendChild(this._historyWidget.domNode);
			}
		},

	    
	    uninitialize: function()
		{
	    	if (this._historyWidget) {
				this._historyWidget.destroyRecursive();
				delete this._historyWidget;
			}
	    	if (this._breadcrumbs) {
				this._breadcrumbs.destroyRecursive();
				delete this._breadcrumbs;
			}
		},

		
	})   
	})();
})();